Bug 847817 - Review Request: libestr - A library to handle strings
Review Request: libestr - A library to handle strings
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Tomas Mraz
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 847811 848388
  Show dependency treegraph
 
Reported: 2012-08-13 11:56 EDT by mahaveer darade
Modified: 2013-03-01 00:30 EST (History)
12 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-12-16 04:36:51 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
tmraz: fedora‑review+
tibbs: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description mahaveer darade 2012-08-13 11:56:09 EDT
Spec URL: http://siddharths.fedorapeople.org/mahaveer/SPECS/libestr.spec
SRPM URL: http://siddharths.fedorapeople.org/mahaveer/SRPMS/libestr-0.1.3-1.fc15.src.rpm
Description: This library implements some helper functions to handle strings and easily escaping special characters etc. It is needed for rsyslog package.

Fedora Account System Username: Mahaveer

This is my second package for review and I need a sponsor.

Here are rpmlint logs.

[mdarade@mdarade rpmbuild]$ rpmlint -i SRPMS/libestr-0.1.3-1.fc15.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[mdarade@mdarade rpmbuild]$ rpmlint -i RPMS/x86_64/libestr-0.1.3-1.fc15.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[mdarade@mdarade rpmbuild]$ rpmlint -i RPMS/x86_64/libestr-devel-0.1.3-1.fc15.x86_64.rpm 
libestr-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

1 packages and 0 specfiles checked; 0 errors, 1 warnings.
[mdarade@mdarade rpmbuild]$ rpmlint -i RPMS/x86_64/libestr-debuginfo-0.1.3-1.fc15.x86_64.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[mdarade@mdarade rpmbuild]$
Comment 1 Milan Bartos 2012-08-27 04:18:45 EDT
Hi, this is just an informational review.

1. you don't need %clean section if you don't plan to support el5
2. you don't need BuildRoot if you don't plan to support el5
3. please don't mix %{buildroot} and $RPM_BUILD_ROOT. just pick one and use it consistently

Milan


---- fedora-review -b 847817 ----

Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated



==== C/C++ ====
[x]: MUST Header files in -devel subpackage, if present.
[x]: MUST ldconfig called in %post and %postun if required.
[x]: MUST Package does not contain any libtool archives (.la)
[ ]: MUST Package does not contain kernel modules.
[ ]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.
[x]: MUST Development (unversioned) .so files in -devel subpackage, if
     present.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[ ]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[ ]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[ ]: MUST Package contains no bundled libraries.
[ ]: MUST Changelog in prescribed format.
[ ]: MUST Sources contain only permissible code or content.
[x]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: Note: defattr macros not found. They would be needed for EPEL5
[ ]: MUST Macros in Summary, %description expandable at SRPM build time.
[ ]: MUST Package contains desktop file if it is a GUI application.
[ ]: MUST Development files must be in a -devel package
[ ]: MUST Package requires other packages for directories it uses.
[ ]: MUST Package uses nothing in %doc for runtime.
[ ]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Fully versioned dependency in subpackages, if present.
[ ]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[ ]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[ ]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "LGPL (v2.1 or later)" For detailed output of
     licensecheck see file: /home/makerpm/847817-libestr/licensecheck.txt
[ ]: MUST License file installed when any subpackage combination is installed.
[!]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
     Note: Using both %{buildroot} and $RPM_BUILD_ROOT
[x]: MUST Package is named using only allowed ascii characters.
[ ]: MUST Package is named according to the Package Naming Guidelines.
[ ]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[ ]: MUST Package obeys FHS, except libexecdir and /usr/target.
[ ]: MUST If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[ ]: MUST Package must own all directories that it creates.
[ ]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[ ]: MUST Package is not relocatable.
[!]: MUST Package requires pkgconfig, if .pc files are present. (EPEL5)
     Note: Only applicable for EL-5
[ ]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[ ]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[ ]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[ ]: MUST Useful -debuginfo package or justification otherwise.
[x]: SHOULD Reviewer should test that the package builds in mock.
[!]: SHOULD Buildroot is not present
     Note: Buildroot is not needed unless packager plans to package for EPEL5
[x]: SHOULD Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean would be needed if support for EPEL5 is required
[ ]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[ ]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[ ]: SHOULD Package functions as described.
[ ]: SHOULD Latest version is packaged.
[ ]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD The placement of pkgconfig(.pc) files are correct.
[ ]: SHOULD Scriptlets must be sane, if used.
[x]: SHOULD SourceX tarball generation or download is documented.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[ ]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[ ]: SHOULD %check is present and all tests pass.
[ ]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
See: None
[!]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
     Note: Using both %{buildroot} and $RPM_BUILD_ROOT
See: http://fedoraproject.org/wiki/Packaging/Guidelines#macros
[!]: MUST Package requires pkgconfig, if .pc files are present. (EPEL5)
     Note: Only applicable for EL-5
See: http://fedoraproject.org/wiki/EPEL/GuidelinesAndPolicies#EL5

Rpmlint
-------
Checking: libestr-devel-0.1.3-1.fc17.x86_64.rpm
          libestr-0.1.3-1.fc17.x86_64.rpm
          libestr-debuginfo-0.1.3-1.fc17.x86_64.rpm
          libestr-0.1.3-1.fc17.src.rpm
libestr-devel.x86_64: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 1 warnings.


Rpmlint (installed packages)
----------------------------
# rpmlint libestr
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
# echo 'rpmlint-done:'

Requires
--------
libestr-devel-0.1.3-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /usr/bin/pkg-config  
    libestr(x86-64) = 0.1.3-1.fc17
    libestr.so.0()(64bit)  

libestr-0.1.3-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    
    /sbin/ldconfig  
    libc.so.6()(64bit)  
    rtld(GNU_HASH)  

libestr-debuginfo-0.1.3-1.fc17.x86_64.rpm (rpmlib, GLIBC filtered):
    

Provides
--------
libestr-devel-0.1.3-1.fc17.x86_64.rpm:
    
    libestr-devel = 0.1.3-1.fc17
    libestr-devel(x86-64) = 0.1.3-1.fc17
    pkgconfig(libestr) = 0.1.3

libestr-0.1.3-1.fc17.x86_64.rpm:
    
    libestr = 0.1.3-1.fc17
    libestr(x86-64) = 0.1.3-1.fc17
    libestr.so.0()(64bit)  

libestr-debuginfo-0.1.3-1.fc17.x86_64.rpm:
    
    libestr-debuginfo = 0.1.3-1.fc17
    libestr-debuginfo(x86-64) = 0.1.3-1.fc17

MD5-sum check
-------------
http://libestr.adiscon.com/files/download/libestr-0.1.3.tar.gz :
  CHECKSUM(SHA256) this package     : 25a4a97942818ceacd8b47370d74a8e09dad2dfeb3c4534e76523e5408973919
  CHECKSUM(SHA256) upstream package : 25a4a97942818ceacd8b47370d74a8e09dad2dfeb3c4534e76523e5408973919


Generated by fedora-review 0.2.2 (9f8c0e5) last change: 2012-08-09
Command line :/usr/bin/fedora-review -b 847817
External plugins:
Comment 2 Milan Bartos 2012-08-27 04:24:27 EDT
4. Packages should try to preserve timestamps of original installed files. => you should use INSTALL='install -p'
Comment 3 mahaveer darade 2012-08-28 07:34:41 EDT
Done. Here are links to updated SPEC & SRPM:

http://siddharths.fedorapeople.org/mahaveer/SPECS/libestr.spec
http://siddharths.fedorapeople.org/mahaveer/SRPMS/libestr-0.1.3-2.fc15.src.rpm


Below are new rpmlint logs:

[root@mdarade guest]# rpmlint  -i libestr.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.
[root@mdarade guest]# rpmlint  -i libestr-0.1.3-2.fc15.src.rpm 
1 packages and 0 specfiles checked; 0 errors, 0 warnings.
[root@mdarade guest]# rpmlint  -i libestr-*x86_64.rpm
libestr-devel.x86_64: W: no-documentation
The package contains no documentation (README, doc, etc). You have to include
documentation files.

3 packages and 0 specfiles checked; 0 errors, 1 warnings.
[root@mdarade guest]#
Comment 4 Michael Schwendt 2012-09-16 14:51:56 EDT
* Version 0.1.4 has been released. Not necessary to package it during review, just mentioning it.


> %build
> make %{?_smp_mflags}

V=1 make ...    for more verbose build output would be beneficial. Else you don't get to see the compiler flags etc.


> make install -p DESTDIR=%{buildroot}

As in the related reviews, there's a mistake in how -p is added here. Should become:

make install INSTALL="install -p" DESTDIR=%{buildroot}


> checking how to associate runtime and link libraries... printf %s\n

That's a strange message in the "configure" output. Something's broken there. Unrelated to the review, just mentioning it.
Comment 5 mahaveer darade 2012-09-20 22:17:15 EDT
I have worked on all the comments provided by Michael and here is a link to updated package. 

http://siddharths.fedorapeople.org/mahaveer/SPECS/libestr.spec
http://siddharths.fedorapeople.org/mahaveer/SRPMS/libestr-0.1.3-3.fc15.src.rpm
Comment 6 Tomas Mraz 2012-10-01 08:36:56 EDT
rpmlint -v libestr-0.1.3-3.fc16.src.rpm libestr-0.1.3-3.fc16.x86_64.rpm libestr-
devel-0.1.3-3.fc16.x86_64.rpm libestr-debuginfo-0.1.3-3.fc16.x86_64.rpm

libestr.src: I: checking
libestr.src: I: checking-url http://libestr.adiscon.com/ (timeout 10 seconds)
libestr.src: I: checking-url http://libestr.adiscon.com/files/download/libestr-0.1.3.tar.gz (timeout 10 seconds)
libestr.x86_64: I: checking
libestr.x86_64: I: checking-url http://libestr.adiscon.com/ (timeout 10 seconds)
libestr-devel.x86_64: I: checking
libestr-devel.x86_64: I: checking-url http://libestr.adiscon.com/ (timeout 10 seconds)
libestr-devel.x86_64: W: no-documentation
libestr-debuginfo.x86_64: I: checking
libestr-debuginfo.x86_64: I: checking-url http://libestr.adiscon.com/ (timeout 10 seconds)
4 packages and 0 specfiles checked; 0 errors, 1 warnings.

The warning above is OK.

Tarball matches the upstream sources.

The package complies with Fedora packaging and licensing guidelines.

Note - the COPYING file states at the beginning that the libestr is packaged under the GNU GPL v2.1 or above but the license is GNU LGPL v2.1 or above as seen in the full text of the license and in the individual source files. Please notify upstream so they can fix the COPYING file appropriately.

The package is ACCEPTED.

I will sponsor you into packagers.
Comment 7 mahaveer darade 2012-10-05 10:50:52 EDT
Updated COPYING. Link to updated files:

http://mdarade.fedorapeople.org/SPECS/libestr.spec
http://mdarade.fedorapeople.org/SRPMS/libestr-0.1.3-4.fc15.src.rpm
Comment 8 Tomas Mraz 2012-10-05 11:01:38 EDT
I don't think the COPYING should be overwritten this way. You should ask upstream to fix it and have it corrected in the next upstream release. There is no problem in shipping the slightly incorrect COPYING meanwhile I think.
Comment 9 mahaveer darade 2012-10-05 12:48:57 EDT
New Package SCM Request
=======================
Package Name: libestr
Short Description: String handling essentials library
Owners: mdarade
Branches: f17 f18
InitialCC:
Comment 10 Jason Tibbitts 2012-10-08 12:26:49 EDT
Git done (by process-git-requests).
Comment 11 Fedora Update System 2012-10-16 11:33:11 EDT
libestr-0.1.3-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/libestr-0.1.3-3.fc17
Comment 12 Fedora Update System 2012-10-16 20:24:19 EDT
libestr-0.1.3-3.fc17 has been pushed to the Fedora 17 testing repository.
Comment 13 Fedora Update System 2012-10-17 06:35:58 EDT
libestr-0.1.3-3.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/libestr-0.1.3-3.fc18

Note You need to log in before you can comment on or make changes to this bug.